Attribute VB_Name = "write"
Option Explicit

Public dplt As Byte

Dim success As Integer
Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" _
(ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, _
ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long

Public Function HTML_write(ByRef matrix_out() As String, ByRef matrix_vlen_up1 As Long, ByRef text_len As Byte) As Byte

Dim table_col_index As Long
Dim table_row_index As Long
Dim table_line As String
Dim colour As String
Dim choose_colour As Byte

Dim chanfile As Long
chanfile = FreeFile

Open App.Path & "\transposition table.html" For Output As #chanfile

Print #chanfile, "<html>"
Print #chanfile, "<head>"
Print #chanfile, "<title>Transposition Table</title>"
Print #chanfile, "</head>"
Print #chanfile, "<body>"
Print #chanfile, "  "
Print #chanfile, "<h1 align=center><font color=navy><u>Transposition Table</u></font></h1>"
Print #chanfile, "<p>Source text: <u>" & matrix_out(1, 1) & "</u><br />"
Print #chanfile, "Text length (and number of columns): " & text_len & "<br />"
Print #chanfile, "Number of rows: " & matrix_vlen_up1 & "<br />"
Print #chanfile, "Total permutations: " & (matrix_vlen_up1 * text_len) & "</p>"
If dplt > 1 Then
Print #chanfile, "<p>The source text has duplicated characters.That is, each character in the source text is not unique. Therefore some (or all) permutations in the table below will also be duplicated.</p>"
End If
Print #chanfile, "<table border=0 cellpadding=2 bordercolorlight=gray bordercolordark=navy cellspacing=2 align=left width =760>"

table_line = ""
For table_col_index = 1 To text_len
table_line = table_line & "<TH><FONT color=orange>" & table_col_index & "</FONT></TH>"
Next table_col_index
Print #chanfile, "<TR align=middle><TH></TH>" & table_line & "</TR>"

For table_row_index = 1 To (matrix_vlen_up1)
table_line = ""
If matrix_out(table_row_index, 1) <> "" Then
For table_col_index = 1 To text_len
If choose_colour = 0 Then
colour = "green"
choose_colour = 1
ElseIf choose_colour = 1 Then
colour = "brown"
choose_colour = 0
End If
table_line = table_line & "<FONT color=" & colour & ">" & matrix_out(table_row_index, table_col_index) & "</FONT></td><td>"
Next table_col_index
Print #chanfile, "<tr align=center><td><FONT color=blue>" & table_row_index & "</FONT></td><td>" & table_line & "</tr>"
End If

choose_colour = 0
Next table_row_index
Print #chanfile, "</table>"
Print #chanfile, "<br clear=all />"
Print #chanfile, "<br clear=all />"
Print #chanfile, "<p>by</p>"
Print #chanfile, "<p>Ziad Cassim</p>"
Print #chanfile, "</body>"
Print #chanfile, "</html>"

Close #chanfile

End Function

Public Function ShellToBrowser%(Frm As Form, ByVal URL$, ByVal WindowStyle%)
    
Dim api%
api% = ShellExecute(Frm.hwnd, "open", URL$, "", App.Path, WindowStyle%)

If api% < 31 Then
ShellToBrowser% = False
ElseIf api% = 32 Then
ShellToBrowser% = False
Else
ShellToBrowser% = True
End If
    
End Function

Public Function Text_write(ByRef matrix_out() As String, ByRef matrix_vlen_up1 As Long, ByRef text_len As Byte) As Byte

Dim text_row_index As Long
Dim text_line_index As Long
Dim text_line As String
Dim chanfile As Long
chanfile = FreeFile
text_line = ""

Open App.Path & "\transposition table.txt" For Output As #chanfile

Print #chanfile, "Transposition Table"
Print #chanfile, ""
Print #chanfile, "Source text: " & matrix_out(1, 1)
Print #chanfile, "Text length (and number of columns): " & text_len
Print #chanfile, "Number of rows: " & matrix_vlen_up1
Print #chanfile, "Total permutations: " & (matrix_vlen_up1 * text_len)
Print #chanfile, ""
If dplt > 1 Then
Print #chanfile, "The source text has duplicated characters."
Print #chanfile, "That is, each character in the source text is not unique."
Print #chanfile, "Therefore some (or all) permutations in the table below will also be duplicated."
End If
Print #chanfile, ""
For text_row_index = 1 To matrix_vlen_up1
text_line = ""
If matrix_out(text_row_index, 1) <> "" Then
For text_line_index = 1 To text_len
text_line = text_line & matrix_out(text_row_index, text_line_index) & ";"
Next text_line_index
Print #chanfile, text_row_index & ". " & text_line
End If
Next text_row_index

Print #chanfile, ""
Print #chanfile, "by"
Print #chanfile, ""
Print #chanfile, "Ziad Cassim"
Close #chanfile

End Function
